/*
Reverse Polish notation

Operand Meaning
D Destination bitmap 
P Selected brush (also called pattern) 
S Source bitmap 

Boolean operators used in these operations follow. 

Operator Meaning 
a Bitwise AND 
n Bitwise NOT (inverse) 
o Bitwise OR 
x Bitwise exclusive OR (XOR) 
*/

#Define ROP_0 00000042h ; BLACKNESS
#Define ROP_DPSoon 00010289h
#Define ROP_DPSona 00020C89h
#Define ROP_PSon 000300AAh
#Define ROP_SDPona 00040C88h
#Define ROP_DPon 000500A9h
#Define ROP_PDSxnon 00060865h
#Define ROP_PDSaon 000702C5h
#Define ROP_SDPnaa 00080F08h
#Define ROP_PDSxon 00090245h
#Define ROP_DPna 000A0329h
#Define ROP_PSDnaon 000B0B2Ah
#Define ROP_SPna 000C0324h
#Define ROP_PDSnaon 000D0B25h
#Define ROP_PDSonon 000E08A5h
#Define ROP_Pn 000F0001h
#Define ROP_PDSona 00100C85h
#Define ROP_DSon 001100A6h  ; NOTSRCERASE
#Define ROP_SDPxnon 00120868h
#Define ROP_SDPaon 001302C8h
#Define ROP_DPSxnon 00140869h
#Define ROP_DPSaon 001502C9h
#Define ROP_PSDPSanaxx 00165CCAh
#Define ROP_SSPxDSxaxn 00171D54h
#Define ROP_SPxPDxa 00180D59h
#Define ROP_SDPSanaxn 00191CC8h
#Define ROP_PDSPaox 001A06C5h
#Define ROP_SDPSxaxn 001B0768h
#Define ROP_PSDPaox 001C06CAh
#Define ROP_DSPDxaxn 001D0766h
#Define ROP_PDSox 001E01A5h
#Define ROP_PDSoan 001F0385h
#Define ROP_DPSnaa 00200F09h
#Define ROP_SDPxon 00210248h
#Define ROP_DSna 00220326h
#Define ROP_SPDnaon 00230B24h
#Define ROP_SPxDSxa 00240D55h
#Define ROP_PDSPanaxn 00251CC5h
#Define ROP_SDPSaox 002606C8h
#Define ROP_SDPSxnox 00271868h
#Define ROP_DPSxa 00280369h
#Define ROP_PSDPSaoxxn 002916CAh
#Define ROP_DPSana 002A0CC9h
#Define ROP_SSPxPDxaxn 002B1D58h
#Define ROP_SPDSoax 002C0784h
#Define ROP_PSDnox 002D060Ah
#Define ROP_PSDPxox 002E064Ah
#Define ROP_PSDnoan 002F0E2Ah
#Define ROP_PSna 0030032Ah
#Define ROP_SDPnaon 00310B28h
#Define ROP_SDPSoox 00320688h
#Define ROP_Sn 00330008h  ; NOTSRCCOPY
#Define ROP_SPDSaox 003406C4h
#Define ROP_SPDSxnox 00351864h
#Define ROP_SDPox 003601A8h
#Define ROP_SDPoan 00370388h
#Define ROP_PSDPoax 0038078Ah
#Define ROP_SPDnox 00390604h
#Define ROP_SPDSxox 003A0644h
#Define ROP_SPDnoan 003B0E24h
#Define ROP_PSx 003C004Ah
#Define ROP_SPDSonox 003D18A4h
#Define ROP_SPDSnaox 003E1B24h
#Define ROP_PSan 003F00EAh
#Define ROP_PSDnaa 00400F0Ah
#Define ROP_DPSxon 00410249h
#Define ROP_SDxPDxa 00420D5Dh
#Define ROP_SPDSanaxn 00431CC4h
#Define ROP_SDna 00440328h  ; SRCERASE
#Define ROP_DPSnaon 00450B29h
#Define ROP_DSPDaox 004606C6h
#Define ROP_PSDPxaxn 0047076Ah
#Define ROP_SDPxa 00480368h
#Define ROP_PDSPDaoxxn 004916C5h
#Define ROP_DPSDoax 004A0789h
#Define ROP_PDSnox 004B0605h
#Define ROP_SDPana 004C0CC8h
#Define ROP_SSPxDSxoxn 004D1954h
#Define ROP_PDSPxox 004E0645h
#Define ROP_PDSnoan 004F0E25h
#Define ROP_PDna 00500325h
#Define ROP_DSPnaon 00510B26h
#Define ROP_DPSDaox 005206C9h
#Define ROP_SPDSxaxn 00530764h
#Define ROP_DPSonon 005408A9h
#Define ROP_Dn 00550009h  ; DSTINVERT
#Define ROP_DPSox 005601A9h
#Define ROP_DPSoan 00570389h
#Define ROP_PDSPoax 00580785h
#Define ROP_DPSnox 00590609h
#Define ROP_DPx 005A0049h ; PATINVERT
#Define ROP_DPSDonox 005B18A9h
#Define ROP_DPSDxox 005C0649h
#Define ROP_DPSnoan 005D0E29h
#Define ROP_DPSDnaox 005E1B29h
#Define ROP_DPan 005F00E9h
#Define ROP_PDSxa 00600365h
#Define ROP_DSPDSaoxxn 006116C6h
#Define ROP_DSPDoax 00620786h
#Define ROP_SDPnox 00630608h
#Define ROP_SDPSoax 00640788h
#Define ROP_DSPnox 00650606h
#Define ROP_DSx 00660046h ; SRCINVERT
#Define ROP_SDPSonox 006718A8h
#Define ROP_DSPDSonoxxn 006858A6h
#Define ROP_PDSxxn 00690145h
#Define ROP_DPSax 006A01E9h
#Define ROP_PSDPSoaxxn 006B178Ah
#Define ROP_SDPax 006C01E8h
#Define ROP_PDSPDoaxxn 006D1785h
#Define ROP_SDPSnoax 006E1E28h
#Define ROP_PDSxnan 006F0C65h
#Define ROP_PDSana 00700CC5h
#Define ROP_SSDxPDxaxn 00711D5Ch
#Define ROP_SDPSxox 00720648h
#Define ROP_SDPnoan 00730E28h
#Define ROP_DSPDxox 00740646h
#Define ROP_DSPnoan 00750E26h
#Define ROP_SDPSnaox 00761B28h
#Define ROP_DSan 007700E6h
#Define ROP_PDSax 007801E5h
#Define ROP_DSPDSoaxxn 00791786h
#Define ROP_DPSDnoax 007A1E29h
#Define ROP_SDPxnan 007B0C68h
#Define ROP_SPDSnoax 007C1E24h
#Define ROP_DPSxnan 007D0C69h
#Define ROP_SPxDSxo 007E0955h
#Define ROP_DPSaan 007F03C9h
#Define ROP_DPSaa 008003E9h
#Define ROP_SPxDSxon 00810975h
#Define ROP_DPSxna 00820C49h
#Define ROP_SPDSnoaxn 00831E04h
#Define ROP_SDPxna 00840C48h
#Define ROP_PDSPnoaxn 00851E05h
#Define ROP_DSPDSoaxx 008617A6h
#Define ROP_PDSaxn 008701C5h
#Define ROP_DSa 008800C6h ; SRCAND
#Define ROP_SDPSnaoxn 00891B08h
#Define ROP_DSPnoa 008A0E06h
#Define ROP_DSPDxoxn 008B0666h
#Define ROP_SDPnoa 008C0E08h
#Define ROP_SDPSxoxn 008D0668h
#Define ROP_SSDxPDxax 008E1D7Ch
#Define ROP_PDSanan 008F0CE5h
#Define ROP_PDSxna 00900C45h
#Define ROP_SDPSnoaxn 00911E08h
#Define ROP_DPSDPoaxx 009217A9h
#Define ROP_SPDaxn 009301C4h
#Define ROP_PSDPSoaxx 009417AAh
#Define ROP_DPSaxn 009501C9h
#Define ROP_DPSxx 00960169h
#Define ROP_PSDPSonoxx 0097588Ah
#Define ROP_SDPSonoxn 00981888h
#Define ROP_DSxn 00990066h
#Define ROP_DPSnax 009A0709h
#Define ROP_SDPSoaxn 009B07A8h
#Define ROP_SPDnax 009C0704h
#Define ROP_DSPDoaxn 009D07A6h
#Define ROP_DSPDSaoxx 009E16E6h
#Define ROP_PDSxan 009F0345h
#Define ROP_DPa 00A000C9h
#Define ROP_PDSPnaoxn 00A11B05h
#Define ROP_DPSnoa 00A20E09h
#Define ROP_DPSDxoxn 00A30669h
#Define ROP_PDSPonoxn 00A41885h
#Define ROP_PDxn 00A50065h
#Define ROP_DSPnax 00A60706h
#Define ROP_PDSPoaxn 00A707A5h
#Define ROP_DPSoa 00A803A9h
#Define ROP_DPSoxn 00A90189h
#Define ROP_D 00AA0029h
#Define ROP_DPSono 00AB0889h
#Define ROP_SPDSxax 00AC0744h
#Define ROP_DPSDaoxn 00AD06E9h
#Define ROP_DSPnao 00AE0B06h
#Define ROP_DPno 00AF0229h
#Define ROP_PDSnoa 00B00E05h
#Define ROP_PDSPxoxn 00B10665h
#Define ROP_SSPxDSxox 00B21974h
#Define ROP_SDPanan 00B30CE8h
#Define ROP_PSDnax 00B4070Ah
#Define ROP_DPSDoaxn 00B507A9h
#Define ROP_DPSDPaoxx 00B616E9h
#Define ROP_SDPxan 00B70348h
#Define ROP_PSDPxax 00B8074Ah
#Define ROP_DSPDaoxn 00B906E6h
#Define ROP_DPSnao 00BA0B09h
#Define ROP_DSno 00BB0226h ; MERGEPAINT
#Define ROP_SPDSanax 00BC1CE4h
#Define ROP_SDxPDxan 00BD0D7Dh
#Define ROP_DPSxo 00BE0269h
#Define ROP_DPSano 00BF08C9h
#Define ROP_PSa 00C000CAh ; MERGECOPY
#Define ROP_SPDSnaoxn 00C11B04h
#Define ROP_SPDSonoxn 00C21884h
#Define ROP_PSxn 00C3006Ah
#Define ROP_SPDnoa 00C40E04h
#Define ROP_SPDSxoxn 00C50664h
#Define ROP_SDPnax 00C60708h
#Define ROP_PSDPoaxn 00C707AAh
#Define ROP_SDPoa 00C803A8h
#Define ROP_SPDoxn 00C90184h
#Define ROP_DPSDxax 00CA0749h
#Define ROP_SPDSaoxn 00CB06E4h
#Define ROP_S 00CC0020h ; SRCCOPY
#Define ROP_SDPono 00CD0888h
#Define ROP_SDPnao 00CE0B08h
#Define ROP_SPno 00CF0224h
#Define ROP_PSDnoa 00D00E0Ah
#Define ROP_PSDPxoxn 00D1066Ah
#Define ROP_PDSnax 00D20705h
#Define ROP_SPDSoaxn 00D307A4h
#Define ROP_SSPxPDxax 00D41D78h
#Define ROP_DPSanan 00D50CE9h
#Define ROP_PSDPSaoxx 00D616EAh
#Define ROP_DPSxan 00D70349h
#Define ROP_PDSPxax 00D80745h
#Define ROP_SDPSaoxn 00D906E8h
#Define ROP_DPSDanax 00DA1CE9h
#Define ROP_SPxDSxan 00DB0D75h
#Define ROP_SPDnao 00DC0B04h
#Define ROP_SDno 00DD0228h
#Define ROP_SDPxo 00DE0268h
#Define ROP_SDPano 00DF08C8h
#Define ROP_PDSoa 00E003A5h
#Define ROP_PDSoxn 00E10185h
#Define ROP_DSPDxax 00E20746h
#Define ROP_PSDPaoxn 00E306EAh
#Define ROP_SDPSxax 00E40748h
#Define ROP_PDSPaoxn 00E506E5h
#Define ROP_SDPSanax 00E61CE8h
#Define ROP_SPxPDxan 00E70D79h
#Define ROP_SSPxDSxax 00E81D74h
#Define ROP_DSPDSanaxxn 00E95CE6h
#Define ROP_DPSao 00EA02E9h
#Define ROP_DPSxno 00EB0849h
#Define ROP_SDPao 00EC02E8h
#Define ROP_SDPxno 00ED0848h
#Define ROP_DSo 00EE0086h ; SRCPAINT
#Define ROP_SDPnoo 00EF0A08h
#Define ROP_P 00F00021h ; PATCOPY
#Define ROP_PDSono 00F10885h
#Define ROP_PDSnao 00F20B05h
#Define ROP_PSno 00F3022Ah
#Define ROP_PSDnao 00F40B0Ah
#Define ROP_PDno 00F50225h
#Define ROP_PDSxo 00F60265h
#Define ROP_PDSano 00F708C5h
#Define ROP_PDSao 00F802E5h
#Define ROP_PDSxno 00F90845h
#Define ROP_DPo 00FA0089h
#Define ROP_DPSnoo 00FB0A09h ; PATPAINT
#Define ROP_PSo 00FC008Ah
#Define ROP_PSDnoo 00FD0A0Ah
#Define ROP_DPSoo 00FE02A9h
#Define ROP_1 00FF0062h ; WHITENESS

#Define BLACKNESS ROP_0
#Define NOTSRCERASE ROP_DSon
#Define NOTSRCCOPY ROP_Sn 
#Define SRCERASE ROP_SDna
#Define DSTINVERT ROP_Dn
#Define PATINVERT ROP_DPx
#Define SRCINVERT ROP_DSx
#Define SRCAND ROP_DSa
#Define MERGEPAINT ROP_DSno
#Define MERGECOPY ROP_PSa
#Define SRCCOPY ROP_S
#Define SRCPAINT ROP_DSo
#Define PATCOPY ROP_P
#Define PATPAINT ROP_DPSnoo
#Define WHITENESS ROP_1
